
--macroScript SaveAndRestoreViews
--category: "About_Viewport"
(
   -- Written by Martin Geupel (http://www.racoon-artworks.de)
   
   perspStore_iso_x = getinisetting "$plugcfg\\RacoonScripts.ini" "perspStore" "pos_x" as integer
   perspStore_iso_y = getinisetting "$plugcfg\\RacoonScripts.ini" "perspStore" "pos_y" as integer
   v1;v2;v3;v4;v5
   
   
   fn MakeThumbnail =(
      grab_bmp = gw.getViewportDib()
      croppedScreenGrab = bitmap grab_bmp.height grab_bmp.height 
      pasteBitmap grab_bmp croppedScreenGrab [((grab_bmp.width - grab_bmp.height)/2)+1,1] [0,0]  -- paste the orginal image to the tempImage, this results in a cropped image widh same height as width
      outputMap  = bitmap 100 100
      copy croppedScreenGrab outputMap 
      close grab_bmp
      close croppedScreenGrab
      
      gc light:true
      outputMap
   )
   
   struct vpSave (
      tmMatrix,
      screenGrab,
      vpType,
      
      fn saveTM =(
         try(
            vpType = viewport.getType()
            tmMatrix = getViewTM()
         )catch()
      ),
      fn getTM =(
         try(
            viewport.setType vpType
            viewport.setTM tmMatrix
         )catch()
      ),
      fn setScreenGrab =(
         screenGrab = (MakeThumbnail())
      )
   )
   
   rollout perspStore "perspective store" width:130(
      button btnView1 "--------" across:2 width:100 height:100 offset:[14,0]
      button btnSave1 "S"  offset:[25,40]
      button btnView2 "--------" across:2 width:100 height:100 offset:[14,0]
      button btnSave2 "S" offset:[25,40]
      button btnView3 "--------" across:2 width:100 height:100 offset:[14,0]
      button btnSave3 "S" offset:[25,40]
      button btnView4 "--------" across:2 width:100 height:100 offset:[14,0]
      button btnSave4 "S" offset:[25,40]
      button btnView5 "--------" across:2 width:100 height:100 offset:[14,0]
      button btnSave5 "S" offset:[25,40]
      
      on btnView1 pressed do v1.getTM()
      on btnView2 pressed do v2.getTM()
      on btnView3 pressed do v3.getTM()
      on btnView4 pressed do v4.getTM()
      on btnView5 pressed do v5.getTM()
      
      on btnSave1 pressed do (v1.saveTM() ; v1.setScreenGrab() ; btnView1.images = #(v1.screengrab, undefined, 1,1,1,1,1) )
      on btnSave2 pressed do (v2.saveTM() ; v2.setScreenGrab() ; btnView2.images = #(v2.screengrab, undefined, 1,1,1,1,1) )
      on btnSave3 pressed do (v3.saveTM() ; v3.setScreenGrab() ; btnView3.images = #(v3.screengrab, undefined, 1,1,1,1,1) )
      on btnSave4 pressed do (v4.saveTM() ; v4.setScreenGrab() ; btnView4.images = #(v4.screengrab, undefined, 1,1,1,1,1) )
      on btnSave5 pressed do (v5.saveTM() ; v5.setScreenGrab() ; btnView5.images = #(v5.screengrab, undefined, 1,1,1,1,1) )
      
      on perspStore open do(
         v1 = vpSave(); v2 = vpSave(); v3 = vpSave(); v4 = vpSave(); v5 = vpSave()
      )
      
      on perspStore close do(
         setinisetting "$plugcfg\\RacoonScripts.ini" "perspStore" "pos_x" ((GetDialogPos perspStore).x  as string)
         setinisetting "$plugcfg\\RacoonScripts.ini" "perspStore" "pos_y" ((GetDialogPos perspStore).y  as string)
      )
   )
   
   createDialog perspStore pos:[perspStore_iso_x, perspStore_iso_y]
)





